function [x,y,typ] = rtai_epos_canopen_aread(job,arg1,arg2)
  x=[];y=[];typ=[];
  select job
  case 'plot' then
    exprs=arg1.graphics.exprs;
    epos_id=exprs(1)
    chn=exprs(6)
    standard_draw(arg1)
  case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
  case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
  case 'getorigin' then
    [x,y]=standard_origin(arg1)
  case 'set' then
    x=arg1
    model=arg1.model;graphics=arg1.graphics;
    exprs=graphics.exprs;
    while %t do
      [ok,epos_id,interf,paddr,baudrate,irq,chn,exprs]=..
      getvalue('Set EPOS data block parameters',..
      ['CAN Id:';
       'Interface:';
       'Port addr:';
       'Baudrate:';
       'Irq:';
       'Analog Channel [0 / 1] :'],..
      list('str',1,'vec',-1,'str',1,'vec',-1,'vec',-1,'vec',-1),exprs)
      if ~ok then break,end
      in=[],
      if exists('outport') then out=ones(outport,1), else out=1, end
      [model,graphics,ok]=check_io(model,graphics,in,out,1,[])
      if ok then
        graphics.exprs=exprs;
        model.rpar=[];
        model.ipar=[hex2dec(strsubst(epos_id,'0x',''));interf;hex2dec(strsubst(paddr,'0x',''));baudrate;irq;chn];
        model.dstate=[];
        x.graphics=graphics;x.model=model
        break
      end
    end
  case 'define' then
    epos_id='0x08'
    interf=1
    paddr='0x378'
    baudrate=2
    irq=5
    chn=1
    model=scicos_model()
    model.sim=list('rt_epos_canopen_aread',4)
    model.in=[],
    if exists('outport') then model.out=ones(outport,1), else model.out=1, end
    model.evtin=1
    model.rpar=[]
    model.ipar=[hex2dec(strsubst(epos_id,'0x',''));interf;hex2dec(strsubst(paddr,'0x',''));baudrate;irq;chn]
    model.dstate=[];
    model.blocktype='d'
    model.dep_ut=[%t %f]
    exprs=[epos_id,sci2exp(interf),paddr,sci2exp(baudrate),sci2exp(irq),sci2exp(chn)]
    gr_i=['xstringb(orig(1),orig(2),[''Epos Analog''; epos_id ; string(chn)],sz(1),sz(2),''fill'');']
    x=standard_define([3 2],model,exprs,gr_i)
  end
endfunction
